/**
 * freesewing | v0.28.1
 * A library for creating made-to-measure sewing patterns
 * (c) 2019 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
function Attributes(){this.list={}}function Point(t,e){this.x=round(t),this.y=round(e),this.attributes=new Attributes}function createCommonjsModule(t,e){return t(e={exports:{}},e.exports),e.exports}Attributes.prototype.add=function(t,e){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(e),this},Attributes.prototype.set=function(t,e){return this.list[t]=[e],this},Attributes.prototype.remove=function(t){return delete this.list[t],this},Attributes.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},Attributes.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},Attributes.prototype.render=function(){var t="";for(var e in this.list)t+=" "+e+'="'+this.list[e].join(" ")+'"';return t},Attributes.prototype.renderAsCss=function(){var t="";for(var e in this.list)t+=" "+e+":"+this.list[e].join(" ")+";";return t},Attributes.prototype.renderIfPrefixIs=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",e="",r=t.length;for(var i in this.list)i.substr(0,r)===t&&(e+=" "+i.substr(r)+'="'+this.list[i].join(" ")+'"');return e},Attributes.prototype.clone=function(){var t=new Attributes;return t.list=JSON.parse(JSON.stringify(this.list)),t},Point.prototype.rad2deg=function(t){return 57.29577951308232*t},Point.prototype.deg2rad=function(t){return t/57.29577951308232},Point.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Point.prototype.dist=function(t){var e=this.x-t.x,r=this.y-t.y;return round(Math.sqrt(Math.pow(e,2)+Math.pow(r,2)))},Point.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},Point.prototype.dx=function(t){return t.x-this.x},Point.prototype.dy=function(t){return t.y-this.y},Point.prototype.angle=function(t){for(var e=Math.atan2(-1*this.dy(t),this.dx(t));e<0;)e+=2*Math.PI;return this.rad2deg(e)},Point.prototype.rotate=function(t,e){var r=this.dist(e),i=this.angle(e);return new Point(e.x+r*Math.cos(this.deg2rad(i+t))*-1,e.y+r*Math.sin(this.deg2rad(i+t)))},Point.prototype.copy=function(){return new Point(this.x,this.y)},Point.prototype.flipX=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new Point(!1===t?-1*this.x:t.x+this.dx(t),this.y)},Point.prototype.flipY=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new Point(this.x,!1===t?-1*this.y:t.y+this.dy(t))},Point.prototype.shift=function(t,e){var r=this.copy();return r.x+=e,r.rotate(t,this)},Point.prototype.shiftTowards=function(t,e){return this.shift(this.angle(t),e)},Point.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},Point.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},Point.prototype.shiftFractionTowards=function(t,e){return this.shiftTowards(t,this.dist(t)*e)},Point.prototype.shiftOutwards=function(t,e){return this.shiftTowards(t,this.dist(t)+e)},Point.prototype.clone=function(){var t=new Point(this.x,this.y);return t.attributes=this.attributes.clone(),t},Point.prototype.translate=function(t,e){var r=this.copy();return r.x+=t,r.y+=e,r};var utils=createCommonjsModule(function(t){var e,r,i,n,o,s,a,h,p,u,f,c,l,y;e=Math.abs,r=Math.cos,i=Math.sin,n=Math.acos,o=Math.atan2,s=Math.sqrt,a=Math.pow,h=function(t){return t<0?-a(-t,1/3):a(t,1/3)},p=Math.PI,u=2*p,f=p/2,c=Number.MAX_SAFE_INTEGER||9007199254740991,l=Number.MIN_SAFE_INTEGER||-9007199254740991,y={Tvalues:[-.06405689286260563,.06405689286260563,-.1911188674736163,.1911188674736163,-.3150426796961634,.3150426796961634,-.4337935076260451,.4337935076260451,-.5454214713888396,.5454214713888396,-.6480936519369755,.6480936519369755,-.7401241915785544,.7401241915785544,-.820001985973903,.820001985973903,-.8864155270044011,.8864155270044011,-.9382745520027328,.9382745520027328,-.9747285559713095,.9747285559713095,-.9951872199970213,.9951872199970213],Cvalues:[.12793819534675216,.12793819534675216,.1258374563468283,.1258374563468283,.12167047292780339,.12167047292780339,.1155056680537256,.1155056680537256,.10744427011596563,.10744427011596563,.09761865210411388,.09761865210411388,.08619016153195327,.08619016153195327,.0733464814110803,.0733464814110803,.05929858491543678,.05929858491543678,.04427743881741981,.04427743881741981,.028531388628933663,.028531388628933663,.0123412297999872,.0123412297999872],arcfn:function(t,e){var r=e(t),i=r.x*r.x+r.y*r.y;return void 0!==r.z&&(i+=r.z*r.z),s(i)},between:function(t,e,r){return e<=t&&t<=r||y.approximately(t,e)||y.approximately(t,r)},approximately:function(t,r,i){return e(t-r)<=(i||1e-6)},length:function(t){var e,r,i=0,n=y.Tvalues.length;for(e=0;e<n;e++)r=.5*y.Tvalues[e]+.5,i+=y.Cvalues[e]*y.arcfn(r,t);return.5*i},map:function(t,e,r,i,n){return i+(n-i)*((t-e)/(r-e))},lerp:function(t,e,r){var i={x:e.x+t*(r.x-e.x),y:e.y+t*(r.y-e.y)};return e.z&&r.z&&(i.z=e.z+t*(r.z-e.z)),i},pointToString:function(t){var e=t.x+"/"+t.y;return void 0!==t.z&&(e+="/"+t.z),e},pointsToString:function(t){return"["+t.map(y.pointToString).join(", ")+"]"},copy:function(t){return JSON.parse(JSON.stringify(t))},angle:function(t,e,r){var i=e.x-t.x,n=e.y-t.y,s=r.x-t.x,a=r.y-t.y;return o(i*a-n*s,i*s+n*a)},round:function(t,e){var r=""+t,i=r.indexOf(".");return parseFloat(r.substring(0,i+1+e))},dist:function(t,e){var r=t.x-e.x,i=t.y-e.y;return s(r*r+i*i)},closest:function(t,e){var r,i,n=a(2,63);return t.forEach(function(t,o){(i=y.dist(e,t))<n&&(n=i,r=o)}),{mdist:n,mpos:r}},abcratio:function(t,r){if(2!==r&&3!==r)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var i=a(t,r)+a(1-t,r);return e((i-1)/i)},projectionratio:function(t,e){if(2!==e&&3!==e)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var r=a(1-t,e);return r/(a(t,e)+r)},lli8:function(t,e,r,i,n,o,s,a){var h=(t-r)*(o-a)-(e-i)*(n-s);return 0!=h&&{x:((t*i-e*r)*(n-s)-(t-r)*(n*a-o*s))/h,y:((t*i-e*r)*(o-a)-(e-i)*(n*a-o*s))/h}},lli4:function(t,e,r,i){var n=t.x,o=t.y,s=e.x,a=e.y,h=r.x,p=r.y,u=i.x,f=i.y;return y.lli8(n,o,s,a,h,p,u,f)},lli:function(t,e){return y.lli4(t,t.c,e,e.c)},makeline:function(t,e){var r=bezier,i=t.x,n=t.y,o=e.x,s=e.y,a=(o-i)/3,h=(s-n)/3;return new r(i,n,i+a,n+h,i+2*a,n+2*h,o,s)},findbbox:function(t){var e=c,r=c,i=l,n=l;return t.forEach(function(t){var o=t.bbox();e>o.x.min&&(e=o.x.min),r>o.y.min&&(r=o.y.min),i<o.x.max&&(i=o.x.max),n<o.y.max&&(n=o.y.max)}),{x:{min:e,mid:(e+i)/2,max:i,size:i-e},y:{min:r,mid:(r+n)/2,max:n,size:n-r}}},shapeintersections:function(t,e,r,i,n){if(!y.bboxoverlap(e,i))return[];var o=[],s=[t.startcap,t.forward,t.back,t.endcap],a=[r.startcap,r.forward,r.back,r.endcap];return s.forEach(function(e){e.virtual||a.forEach(function(i){if(!i.virtual){var s=e.intersects(i,n);s.length>0&&(s.c1=e,s.c2=i,s.s1=t,s.s2=r,o.push(s))}})}),o},makeshape:function(t,e,r){var i=e.points.length,n=t.points.length,o=y.makeline(e.points[i-1],t.points[0]),s=y.makeline(t.points[n-1],e.points[0]),a={startcap:o,forward:t,back:e,endcap:s,bbox:y.findbbox([o,t,e,s])},h=y;return a.intersections=function(t){return h.shapeintersections(a,a.bbox,t,t.bbox,r)},a},getminmax:function(t,e,r){if(!r)return{min:0,max:0};var i,n,o=c,s=l;-1===r.indexOf(0)&&(r=[0].concat(r)),-1===r.indexOf(1)&&r.push(1);for(var a=0,h=r.length;a<h;a++)i=r[a],(n=t.get(i))[e]<o&&(o=n[e]),n[e]>s&&(s=n[e]);return{min:o,mid:(o+s)/2,max:s,size:s-o}},align:function(t,e){var n=e.p1.x,s=e.p1.y,a=-o(e.p2.y-s,e.p2.x-n);return t.map(function(t){return{x:(t.x-n)*r(a)-(t.y-s)*i(a),y:(t.x-n)*i(a)+(t.y-s)*r(a)}})},roots:function(t,e){e=e||{p1:{x:0,y:0},p2:{x:1,y:0}};var i=t.length-1,o=y.align(t,e),a=function(t){return 0<=t&&t<=1};if(2===i){if(0!==(d=(x=o[0].y)-2*(g=o[1].y)+(m=o[2].y))){var p=-s(g*g-x*m),f=-x+g;return[-(p+f)/d,-(-p+f)/d].filter(a)}return g!==m&&0===d?[(2*g-m)/2*(g-m)].filter(a):[]}var c=o[0].y,l=o[1].y,v=o[2].y,d=3*l-c-3*v+o[3].y,x=3*c-6*l+3*v,g=-3*c+3*l,m=c;if(y.approximately(d,0)){if(y.approximately(x,0))return y.approximately(g,0)?[]:[-m/g].filter(a);var b=2*x;return[((w=s(g*g-4*x*m))-g)/b,(-g-w)/b].filter(a)}var w,P,z=(o=(3*(g/=d)-(x/=d)*x)/3)/3,S=(w=(2*x*x*x-9*x*g+27*(m/=d))/27)/2,O=S*S+z*z*z;if(O<0){var _=-o/3,k=s(_*_*_),M=-w/(2*k),A=n(M<-1?-1:M>1?1:M),I=2*h(k);return[I*r(A/3)-x/3,I*r((A+u)/3)-x/3,I*r((A+2*u)/3)-x/3].filter(a)}if(0===O)return[2*(P=S<0?h(-S):-h(S))-x/3,-P-x/3].filter(a);var L=s(O);return[(P=h(-S+L))-h(S+L)-x/3].filter(a)},droots:function(t){if(3===t.length){var e=t[0],r=t[1],i=t[2],n=e-2*r+i;if(0!==n){var o=-s(r*r-e*i),a=-e+r;return[-(o+a)/n,-(-o+a)/n]}return r!==i&&0===n?[(2*r-i)/(2*(r-i))]:[]}if(2===t.length)return(e=t[0])!==(r=t[1])?[e/(e-r)]:[]},inflections:function(t){if(t.length<4)return[];var e=y.align(t,{p1:t[0],p2:t.slice(-1)[0]}),r=e[2].x*e[1].y,i=e[3].x*e[1].y,n=e[1].x*e[2].y,o=18*(-3*r+2*i+3*n-(f=e[3].x*e[2].y)),s=18*(3*r-i-3*n),a=18*(n-r);if(y.approximately(o,0)){if(!y.approximately(s,0)){var h=-a/s;if(0<=h&&h<=1)return[h]}return[]}var p=s*s-4*o*a,u=Math.sqrt(p),f=2*o;return y.approximately(f,0)?[]:[(u-s)/f,-(s+u)/f].filter(function(t){return 0<=t&&t<=1})},bboxoverlap:function(t,r){var i,n,o,s,a,h=["x","y"],p=h.length;for(i=0;i<p;i++)if(o=t[n=h[i]].mid,s=r[n].mid,a=(t[n].size+r[n].size)/2,e(o-s)>=a)return!1;return!0},expandbox:function(t,e){e.x.min<t.x.min&&(t.x.min=e.x.min),e.y.min<t.y.min&&(t.y.min=e.y.min),e.z&&e.z.min<t.z.min&&(t.z.min=e.z.min),e.x.max>t.x.max&&(t.x.max=e.x.max),e.y.max>t.y.max&&(t.y.max=e.y.max),e.z&&e.z.max>t.z.max&&(t.z.max=e.z.max),t.x.mid=(t.x.min+t.x.max)/2,t.y.mid=(t.y.min+t.y.max)/2,t.z&&(t.z.mid=(t.z.min+t.z.max)/2),t.x.size=t.x.max-t.x.min,t.y.size=t.y.max-t.y.min,t.z&&(t.z.size=t.z.max-t.z.min)},pairiteration:function(t,e,r){var i=t.bbox(),n=e.bbox(),o=1e5,s=r||.5;if(i.x.size+i.y.size<s&&n.x.size+n.y.size<s)return[(o*(t._t1+t._t2)/2|0)/o+"/"+(o*(e._t1+e._t2)/2|0)/o];var a=t.split(.5),h=e.split(.5),p=[{left:a.left,right:h.left},{left:a.left,right:h.right},{left:a.right,right:h.right},{left:a.right,right:h.left}];p=p.filter(function(t){return y.bboxoverlap(t.left.bbox(),t.right.bbox())});var u=[];return 0===p.length?u:(p.forEach(function(t){u=u.concat(y.pairiteration(t.left,t.right,s))}),u=u.filter(function(t,e){return u.indexOf(t)===e}))},getccenter:function(t,e,n){var s,a=e.x-t.x,h=e.y-t.y,p=n.x-e.x,c=n.y-e.y,l=a*r(f)-h*i(f),v=a*i(f)+h*r(f),d=p*r(f)-c*i(f),x=p*i(f)+c*r(f),g=(t.x+e.x)/2,m=(t.y+e.y)/2,b=(e.x+n.x)/2,w=(e.y+n.y)/2,P=g+l,z=m+v,S=b+d,O=w+x,_=y.lli8(g,m,P,z,b,w,S,O),k=y.dist(_,t),M=o(t.y-_.y,t.x-_.x),A=o(e.y-_.y,e.x-_.x),I=o(n.y-_.y,n.x-_.x);return M<I?((M>A||A>I)&&(M+=u),M>I&&(s=I,I=M,M=s)):I<A&&A<M?(s=I,I=M,M=s):I+=u,_.s=M,_.e=I,_.r=k,_},numberSort:function(t,e){return t-e}},t.exports=y}),polyBezier=createCommonjsModule(function(t){var e,r;e=utils,(r=function(t){this.curves=[],this._3d=!1,t&&(this.curves=t,this._3d=this.curves[0]._3d)}).prototype={valueOf:function(){return this.toString()},toString:function(){return"["+this.curves.map(function(t){return e.pointsToString(t.points)}).join(", ")+"]"},addCurve:function(t){this.curves.push(t),this._3d=this._3d||t._3d},length:function(){return this.curves.map(function(t){return t.length()}).reduce(function(t,e){return t+e})},curve:function(t){return this.curves[t]},bbox:function(){for(var t=this.curves,r=t[0].bbox(),i=1;i<t.length;i++)e.expandbox(r,t[i].bbox());return r},offset:function(t){var e=[];return this.curves.forEach(function(r){e=e.concat(r.offset(t))}),new r(e)}},t.exports=r});function normalizePath(t){var e,r,i,n,o,s,a=(t=t.replace(/,/g," ").replace(/-/g," - ").replace(/-\s+/g,"-").replace(/([a-zA-Z])/g," $1 ")).replace(/([a-zA-Z])\s?/g,"|$1").split("|"),h=a.length,p=[],u=0,f=0,c=0,l=0,y=0,v=0,d=0,x=0,g="";for(e=1;e<h;e++)if(n=(i=(r=a[e]).substring(0,1)).toLowerCase(),o=(p=(p=r.replace(i,"").trim().split(" ")).filter(function(t){return""!==t}).map(parseFloat)).length,"m"===n){if(g+="M ","m"===i?(c+=p[0],l+=p[1]):(c=p[0],l=p[1]),u=c,f=l,g+=c+" "+l+" ",o>2)for(s=0;s<o;s+=2)"m"===i?(c+=p[s],l+=p[s+1]):(c=p[s],l=p[s+1]),g+=["L",c,l,""].join(" ")}else if("l"===n)for(s=0;s<o;s+=2)"l"===i?(c+=p[s],l+=p[s+1]):(c=p[s],l=p[s+1]),g+=["L",c,l,""].join(" ");else if("h"===n)for(s=0;s<o;s++)"h"===i?c+=p[s]:c=p[s],g+=["L",c,l,""].join(" ");else if("v"===n)for(s=0;s<o;s++)"v"===i?l+=p[s]:l=p[s],g+=["L",c,l,""].join(" ");else if("q"===n)for(s=0;s<o;s+=4)"q"===i?(y=c+p[s],v=l+p[s+1],c+=p[s+2],l+=p[s+3]):(y=p[s],v=p[s+1],c=p[s+2],l=p[s+3]),g+=["Q",y,v,c,l,""].join(" ");else if("t"===n)for(s=0;s<o;s+=2)y=c+(c-y),v=l+(l-v),"t"===i?(c+=p[s],l+=p[s+1]):(c=p[s],l=p[s+1]),g+=["Q",y,v,c,l,""].join(" ");else if("c"===n)for(s=0;s<o;s+=6)"c"===i?(y=c+p[s],v=l+p[s+1],d=c+p[s+2],x=l+p[s+3],c+=p[s+4],l+=p[s+5]):(y=p[s],v=p[s+1],d=p[s+2],x=p[s+3],c=p[s+4],l=p[s+5]),g+=["C",y,v,d,x,c,l,""].join(" ");else if("s"===n)for(s=0;s<o;s+=4)y=c+(c-d),v=l+(l-x),"s"===i?(d=c+p[s],x=l+p[s+1],c+=p[s+2],l+=p[s+3]):(d=p[s],x=p[s+1],c=p[s+2],l=p[s+3]),g+=["C",y,v,d,x,c,l,""].join(" ");else"z"===n&&(g+="Z ",c=u,l=f);return g.trim()}var normaliseSvg=normalizePath,M={x:!1,y:!1};function makeBezier(t,e,r){if("Z"!==e){if("M"!==e){var i=[!1,M.x,M.y].concat(r),n=new(t.bind.apply(t,i)),o=r.slice(-2);return M={x:o[0],y:o[1]},n}M={x:r[0],y:r[1]}}}function convertPath(t,e){for(var r,i,n=normaliseSvg(e).split(" "),o=new RegExp("[MLCQZ]",""),s=[],a={C:6,Q:4,L:2,M:2};n.length;)r=n.splice(0,1)[0],o.test(r)&&(i=makeBezier(t,r,n.splice(0,a[r]).map(parseFloat)))&&s.push(i);return new t.PolyBezier(s)}var svgToBeziers=convertPath,bezier=createCommonjsModule(function(t){!function(){var e=Math.abs,r=Math.min,i=Math.max,n=Math.cos,o=Math.sin,s=Math.acos,a=Math.sqrt,h=Math.PI,p={x:0,y:0,z:0},u=utils,f=polyBezier,c=function(t){var r=t&&t.forEach?t:[].slice.call(arguments),i=!1;if("object"==typeof r[0]){i=r.length;var n=[];r.forEach(function(t){["x","y","z"].forEach(function(e){void 0!==t[e]&&n.push(t[e])})}),r=n}var o=!1,s=r.length;if(i){if(i>4){if(1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");o=!0}}else if(6!==s&&8!==s&&9!==s&&12!==s&&1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");var a=!o&&(9===s||12===s)||t&&t[0]&&void 0!==t[0].z;this._3d=a;for(var h=[],p=0,f=a?3:2;p<s;p+=f){var c={x:r[p],y:r[p+1]};a&&(c.z=r[p+2]),h.push(c)}this.order=h.length-1,this.points=h;var l=["x","y"];a&&l.push("z"),this.dims=l,this.dimlen=l.length,function(t){for(var r=t.order,i=t.points,n=u.align(i,{p1:i[0],p2:i[r]}),o=0;o<n.length;o++)if(e(n[o].y)>1e-4)return void(t._linear=!1);t._linear=!0}(this),this._t1=0,this._t2=1,this.update()},l=svgToBeziers;function y(t,e,r,i,n){void 0===n&&(n=.5);var o=u.projectionratio(n,t),s=1-o,a={x:o*e.x+s*i.x,y:o*e.y+s*i.y},h=u.abcratio(n,t);return{A:{x:r.x+(r.x-a.x)/h,y:r.y+(r.y-a.y)/h},B:r,C:a}}c.SVGtoBeziers=function(t){return l(c,t)},c.quadraticFromPoints=function(t,e,r,i){if(void 0===i&&(i=.5),0===i)return new c(e,e,r);if(1===i)return new c(t,e,e);var n=y(2,t,e,r,i);return new c(t,n.A,r)},c.cubicFromPoints=function(t,e,r,i,n){void 0===i&&(i=.5);var o=y(3,t,e,r,i);void 0===n&&(n=u.dist(e,o.C));var s=n*(1-i)/i,a=u.dist(t,r),h=(r.x-t.x)/a,p=(r.y-t.y)/a,f=n*h,l=n*p,v=s*h,d=s*p,x=e.x-f,g=e.y-l,m=e.x+v,b=e.y+d,w=o.A,P=w.x+(x-w.x)/(1-i),z=w.y+(g-w.y)/(1-i),S=w.x+(m-w.x)/i,O=w.y+(b-w.y)/i,_={x:t.x+(P-t.x)/i,y:t.y+(z-t.y)/i},k={x:r.x+(S-r.x)/(1-i),y:r.y+(O-r.y)/(1-i)};return new c(t,_,k,r)};var v=function(){return u};c.getUtils=v,c.PolyBezier=f,c.prototype={getUtils:v,valueOf:function(){return this.toString()},toString:function(){return u.pointsToString(this.points)},toSVG:function(t){if(this._3d)return!1;for(var e=this.points,r=["M",e[0].x,e[0].y,2===this.order?"Q":"C"],i=1,n=e.length;i<n;i++)r.push(e[i].x),r.push(e[i].y);return r.join(" ")},update:function(){this.dpoints=[];for(var t=this.points,e=t.length,r=e-1;e>1;e--,r--){for(var i,n=[],o=0;o<r;o++)i={x:r*(t[o+1].x-t[o].x),y:r*(t[o+1].y-t[o].y)},this._3d&&(i.z=r*(t[o+1].z-t[o].z)),n.push(i);this.dpoints.push(n),t=n}this.computedirection()},computedirection:function(){var t=this.points,e=u.angle(t[0],t[this.order],t[1]);this.clockwise=e>0},length:function(){return u.length(this.derivative.bind(this))},_lut:[],getLUT:function(t){if(t=t||100,this._lut.length===t)return this._lut;this._lut=[],t--;for(var e=0;e<=t;e++)this._lut.push(this.compute(e/t));return this._lut},on:function(t,e){e=e||5;for(var r,i=this.getLUT(),n=[],o=0,s=0;s<i.length;s++)r=i[s],u.dist(r,t)<e&&(n.push(r),o+=s/i.length);return!!n.length&&o/n.length},project:function(t){var e=this.getLUT(),r=e.length-1,i=u.closest(e,t),n=i.mdist,o=i.mpos;if(0===o||o===r){var s=o/r,a=this.compute(s);return a.t=s,a.d=n,a}var h,p,f,c=(o+1)/r,l=.1/r;for(n+=1,h=s=(o-1)/r;s<c+l;s+=l)p=this.compute(s),(f=u.dist(t,p))<n&&(n=f,h=s);return(p=this.compute(h)).t=h,p.d=n,p},get:function(t){return this.compute(t)},point:function(t){return this.points[t]},compute:function(t){if(0===t)return this.points[0];if(1===t)return this.points[this.order];var e=this.points,r=1-t;if(1===this.order)return u={x:r*e[0].x+t*e[1].x,y:r*e[0].y+t*e[1].y},this._3d&&(u.z=r*e[0].z+t*e[1].z),u;if(this.order<4){var i,n,o,s=r*r,a=t*t,h=0;2===this.order?(e=[e[0],e[1],e[2],p],i=s,n=r*t*2,o=a):3===this.order&&(i=s*r,n=s*t*3,o=r*a*3,h=t*a);var u={x:i*e[0].x+n*e[1].x+o*e[2].x+h*e[3].x,y:i*e[0].y+n*e[1].y+o*e[2].y+h*e[3].y};return this._3d&&(u.z=i*e[0].z+n*e[1].z+o*e[2].z+h*e[3].z),u}for(var f=JSON.parse(JSON.stringify(this.points));f.length>1;){for(var c=0;c<f.length-1;c++)f[c]={x:f[c].x+(f[c+1].x-f[c].x)*t,y:f[c].y+(f[c+1].y-f[c].y)*t},void 0!==f[c].z&&(f[c]=f[c].z+(f[c+1].z-f[c].z)*t);f.splice(f.length-1,1)}return f[0]},raise:function(){for(var t,e,r=this.points,i=[r[0]],n=r.length,o=1;o<n;o++)t=r[o],e=r[o-1],i[o]={x:(n-o)/n*t.x+o/n*e.x,y:(n-o)/n*t.y+o/n*e.y};return i[n]=r[n-1],new c(i)},derivative:function(t){var e,r,i=1-t,n=0,o=this.dpoints[0];2===this.order&&(o=[o[0],o[1],p],e=i,r=t),3===this.order&&(e=i*i,r=i*t*2,n=t*t);var s={x:e*o[0].x+r*o[1].x+n*o[2].x,y:e*o[0].y+r*o[1].y+n*o[2].y};return this._3d&&(s.z=e*o[0].z+r*o[1].z+n*o[2].z),s},inflections:function(){return u.inflections(this.points)},normal:function(t){return this._3d?this.__normal3(t):this.__normal2(t)},__normal2:function(t){var e=this.derivative(t),r=a(e.x*e.x+e.y*e.y);return{x:-e.y/r,y:e.x/r}},__normal3:function(t){var e=this.derivative(t),r=this.derivative(t+.01),i=a(e.x*e.x+e.y*e.y+e.z*e.z),n=a(r.x*r.x+r.y*r.y+r.z*r.z);e.x/=i,e.y/=i,e.z/=i,r.x/=n,r.y/=n,r.z/=n;var o={x:r.y*e.z-r.z*e.y,y:r.z*e.x-r.x*e.z,z:r.x*e.y-r.y*e.x},s=a(o.x*o.x+o.y*o.y+o.z*o.z);o.x/=s,o.y/=s,o.z/=s;var h=[o.x*o.x,o.x*o.y-o.z,o.x*o.z+o.y,o.x*o.y+o.z,o.y*o.y,o.y*o.z-o.x,o.x*o.z-o.y,o.y*o.z+o.x,o.z*o.z];return{x:h[0]*e.x+h[1]*e.y+h[2]*e.z,y:h[3]*e.x+h[4]*e.y+h[5]*e.z,z:h[6]*e.x+h[7]*e.y+h[8]*e.z}},hull:function(t){var e,r=this.points,i=[],n=[],o=0,s=0,a=0;for(n[o++]=r[0],n[o++]=r[1],n[o++]=r[2],3===this.order&&(n[o++]=r[3]);r.length>1;){for(i=[],s=0,a=r.length-1;s<a;s++)e=u.lerp(t,r[s],r[s+1]),n[o++]=e,i.push(e);r=i}return n},split:function(t,e){if(0===t&&e)return this.split(e).left;if(1===e)return this.split(t).right;var r=this.hull(t),i={left:2===this.order?new c([r[0],r[3],r[5]]):new c([r[0],r[4],r[7],r[9]]),right:2===this.order?new c([r[5],r[4],r[2]]):new c([r[9],r[8],r[6],r[3]]),span:r};return i.left._t1=u.map(0,0,1,this._t1,this._t2),i.left._t2=u.map(t,0,1,this._t1,this._t2),i.right._t1=u.map(t,0,1,this._t1,this._t2),i.right._t2=u.map(1,0,1,this._t1,this._t2),e?(e=u.map(e,t,1,0,1),i.right.split(e).left):i},extrema:function(){var t,e,r=this.dims,i={},n=[];return r.forEach(function(r){e=function(t){return t[r]},t=this.dpoints[0].map(e),i[r]=u.droots(t),3===this.order&&(t=this.dpoints[1].map(e),i[r]=i[r].concat(u.droots(t))),i[r]=i[r].filter(function(t){return t>=0&&t<=1}),n=n.concat(i[r].sort(u.numberSort))}.bind(this)),n=n.sort(u.numberSort).filter(function(t,e){return n.indexOf(t)===e}),i.values=n,i},bbox:function(){var t=this.extrema(),e={};return this.dims.forEach(function(r){e[r]=u.getminmax(this,r,t[r])}.bind(this)),e},overlaps:function(t){var e=this.bbox(),r=t.bbox();return u.bboxoverlap(e,r)},offset:function(t,e){if(void 0!==e){var r=this.get(t),i=this.normal(t),n={c:r,n:i,x:r.x+i.x*e,y:r.y+i.y*e};return this._3d&&(n.z=r.z+i.z*e),n}if(this._linear){var o=this.normal(0),s=this.points.map(function(e){var r={x:e.x+t*o.x,y:e.y+t*o.y};return e.z&&i.z&&(r.z=e.z+t*o.z),r});return[new c(s)]}return this.reduce().map(function(e){return e.scale(t)})},simple:function(){if(3===this.order){var t=u.angle(this.points[0],this.points[3],this.points[1]),r=u.angle(this.points[0],this.points[3],this.points[2]);if(t>0&&r<0||t<0&&r>0)return!1}var i=this.normal(0),n=this.normal(1),o=i.x*n.x+i.y*n.y;return this._3d&&(o+=i.z*n.z),e(s(o))<h/3},reduce:function(){var t,r,i=0,n=0,o=[],s=[],a=this.extrema().values;for(-1===a.indexOf(0)&&(a=[0].concat(a)),-1===a.indexOf(1)&&a.push(1),i=a[0],t=1;t<a.length;t++)n=a[t],(r=this.split(i,n))._t1=i,r._t2=n,o.push(r),i=n;return o.forEach(function(t){for(i=0,n=0;n<=1;)for(n=i+.01;n<=1.01;n+=.01)if(!(r=t.split(i,n)).simple()){if(e(i-(n-=.01))<.01)return[];(r=t.split(i,n))._t1=u.map(i,0,1,t._t1,t._t2),r._t2=u.map(n,0,1,t._t1,t._t2),s.push(r),i=n;break}i<1&&((r=t.split(i,1))._t1=u.map(i,0,1,t._t1,t._t2),r._t2=t._t2,s.push(r))}),s},scale:function(t){var e=this.order,r=!1;if("function"==typeof t&&(r=t),r&&2===e)return this.raise().scale(r);var i=this.clockwise,n=r?r(0):t,o=r?r(1):t,s=[this.offset(0,10),this.offset(1,10)],h=u.lli4(s[0],s[0].c,s[1],s[1].c);if(!h)throw new Error("cannot scale this curve. Try reducing it first.");var p=this.points,f=[];return[0,1].forEach(function(t){var r=f[t*e]=u.copy(p[t*e]);r.x+=(t?o:n)*s[t].n.x,r.y+=(t?o:n)*s[t].n.y}.bind(this)),r?([0,1].forEach(function(n){if(2!==this.order||!n){var o=p[n+1],s={x:o.x-h.x,y:o.y-h.y},u=r?r((n+1)/e):t;r&&!i&&(u=-u);var c=a(s.x*s.x+s.y*s.y);s.x/=c,s.y/=c,f[n+1]={x:o.x+u*s.x,y:o.y+u*s.y}}}.bind(this)),new c(f)):([0,1].forEach(function(t){if(2!==this.order||!t){var r=f[t*e],i=this.derivative(t),n={x:r.x+i.x,y:r.y+i.y};f[t+1]=u.lli4(r,n,h,p[t+1])}}.bind(this)),new c(f))},outline:function(t,e,r,i){e=void 0===e?t:e;var n,o=this.reduce(),s=o.length,a=[],h=[],p=0,c=this.length(),l=void 0!==r&&void 0!==i;function y(t,e,r,i,n){return function(o){var s=i/r,a=(i+n)/r,h=e-t;return u.map(o,0,1,t+s*h,t+a*h)}}o.forEach(function(n){P=n.length(),l?(a.push(n.scale(y(t,r,c,p,P))),h.push(n.scale(y(-e,-i,c,p,P)))):(a.push(n.scale(t)),h.push(n.scale(-e))),p+=P}),h=h.map(function(t){return(n=t.points)[3]?t.points=[n[3],n[2],n[1],n[0]]:t.points=[n[2],n[1],n[0]],t}).reverse();var v=a[0].points[0],d=a[s-1].points[a[s-1].points.length-1],x=h[s-1].points[h[s-1].points.length-1],g=h[0].points[0],m=u.makeline(x,v),b=u.makeline(d,g),w=[m].concat(a).concat([b]).concat(h),P=w.length;return new f(w)},outlineshapes:function(t,e,r){e=e||t;for(var i=this.outline(t,e).curves,n=[],o=1,s=i.length;o<s/2;o++){var a=u.makeshape(i[o],i[s-o],r);a.startcap.virtual=o>1,a.endcap.virtual=o<s/2-1,n.push(a)}return n},intersects:function(t,e){return t?t.p1&&t.p2?this.lineIntersects(t):(t instanceof c&&(t=t.reduce()),this.curveintersects(this.reduce(),t,e)):this.selfintersects(e)},lineIntersects:function(t){var e=r(t.p1.x,t.p2.x),n=r(t.p1.y,t.p2.y),o=i(t.p1.x,t.p2.x),s=i(t.p1.y,t.p2.y),a=this;return u.roots(this.points,t).filter(function(t){var r=a.get(t);return u.between(r.x,e,o)&&u.between(r.y,n,s)})},selfintersects:function(t){var e,r,i,n,o=this.reduce(),s=o.length-2,a=[];for(e=0;e<s;e++)i=o.slice(e,e+1),n=o.slice(e+2),r=this.curveintersects(i,n,t),a=a.concat(r);return a},curveintersects:function(t,e,r){var i=[];t.forEach(function(t){e.forEach(function(e){t.overlaps(e)&&i.push({left:t,right:e})})});var n=[];return i.forEach(function(t){var e=u.pairiteration(t.left,t.right,r);e.length>0&&(n=n.concat(e))}),n},arcs:function(t){t=t||.5;return this._iterate(t,[])},_error:function(t,r,i,n){var o=(n-i)/4,s=this.get(i+o),a=this.get(n-o),h=u.dist(t,r),p=u.dist(t,s),f=u.dist(t,a);return e(p-h)+e(f-h)},_iterate:function(t,e){var r,i=0,s=1;do{r=0,s=1;var a,h,p,f,c,l=this.get(i),y=!1,v=!1,d=s,x=1;do{if(v=y,f=p,d=(i+s)/2,a=this.get(d),h=this.get(s),(p=u.getccenter(l,a,h)).interval={start:i,end:s},y=this._error(p,l,i,s)<=t,(c=v&&!y)||(x=s),y){if(s>=1){if(p.interval.end=x=1,f=p,s>1){var g={x:p.x+p.r*n(p.e),y:p.y+p.r*o(p.e)};p.e+=u.angle({x:p.x,y:p.y},g,this.get(1))}break}s+=(s-i)/2}else s=d}while(!c&&r++<100);if(r>=100)break;f=f||p,e.push(f),i=x}while(s<1);return e}},t.exports=c}()}),bezierJs=bezier;function capitalize(t){return t.charAt(0).toUpperCase()+t.slice(1)}function macroName(t){return"_macro_"+t}function beamsIntersect(t,e,r,i){var n=t.slope(e),o=r.slope(i);if(n===o)return!1;if(t.x===e.x)return new Point(t.x,o*t.x+(r.y-o*r.x));if(r.x===i.x)return new Point(r.x,n*r.x+(t.y-n*t.x));t.x>e.x&&(t=e.copy()),r.x>i.x&&(r=i.copy());var s=t.y-n*t.x,a=(r.y-o*r.x-s)/(n-o);return new Point(a,n*a+s)}function linesIntersect(t,e,r,i){var n=beamsIntersect(t,e,r,i);if(!n)return!1;var o=t.dist(e),s=r.dist(i),a=t.dist(n)+n.dist(e),h=r.dist(n)+n.dist(i);return Math.round(o)==Math.round(a)&&Math.round(s)==Math.round(h)&&n}function pointOnBeam(t,e,r){var i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6;if(t.sitsOn(r))return!0;if(e.sitsOn(r))return!0;var n=r.dx(t)*e.dy(t)-r.dy(t)*e.dx(t);return 0===Math.abs(Math.round(n*i)/i)}function pointOnLine(t,e,r){if(!pointOnBeam(t,e,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6))return!1;var i=t.dist(e),n=t.dist(r)+r.dist(e);return Math.round(i)==Math.round(n)}function pointOnCurve(t,e,r,i,n){if(t.sitsOn(n))return!0;if(i.sitsOn(n))return!0;var o=new bezierJs({x:t.x,y:t.y},{x:e.x,y:e.y},{x:r.x,y:r.y},{x:i.x,y:i.y}).intersects({p1:{x:n.x-1,y:n.y},p2:{x:n.x+1,y:n.y}});return o.length>0&&o.shift()}function beamIntersectsX(t,e,r){return t.x!==e.x&&beamsIntersect(t,e,new Point(r,-10),new Point(r,10))}function beamIntersectsY(t,e,r){return t.y!==e.y&&beamsIntersect(t,e,new Point(-10,r),new Point(10,r))}function units(t){return"imperial"===(arguments.length>1&&void 0!==arguments[1]?arguments[1]:"metric")?round(t/25.4)+'"':round(t/10)+"cm"}function lineIntersectsCurve(t,e,r,i,n,o){var s=[],a=new bezierJs({x:r.x,y:r.y},{x:i.x,y:i.y},{x:n.x,y:n.y},{x:o.x,y:o.y}),h={p1:{x:t.x,y:t.y},p2:{x:e.x,y:e.y}},p=!0,u=!1,f=void 0;try{for(var c,l=a.intersects(h)[Symbol.iterator]();!(p=(c=l.next()).done);p=!0){var y=c.value,v=a.get(y);s.push(new Point(v.x,v.y))}}catch(t){u=!0,f=t}finally{try{!p&&l.return&&l.return()}finally{if(u)throw f}}return 0!==s.length&&(1===s.length?s[0]:s)}function curvesIntersect(t,e,r,i,n,o,s,a){var h=[],p=new bezierJs({x:t.x,y:t.y},{x:e.x,y:e.y},{x:r.x,y:r.y},{x:i.x,y:i.y}),u=new bezierJs({x:n.x,y:n.y},{x:o.x,y:o.y},{x:s.x,y:s.y},{x:a.x,y:a.y}),f=!0,c=!1,l=void 0;try{for(var y,v=p.intersects(u,.005)[Symbol.iterator]();!(f=(y=v.next()).done);f=!0){var d=y.value,x=p.get(d.substr(0,d.indexOf("/")));h.push(new Point(x.x,x.y))}}catch(t){c=!0,l=t}finally{try{!f&&v.return&&v.return()}finally{if(c)throw l}}if(0===h.length)return!1;if(1===h.length)return h.shift();var g=[],m=!0,b=!1,w=void 0;try{for(var P,z=h[Symbol.iterator]();!(m=(P=z.next()).done);m=!0){var S=P.value,O=!1,_=!0,k=!1,M=void 0;try{for(var A,I=g[Symbol.iterator]();!(_=(A=I.next()).done);_=!0){var L=A.value;S.sitsRoughlyOn(L)&&(O=!0)}}catch(t){k=!0,M=t}finally{try{!_&&I.return&&I.return()}finally{if(k)throw M}}O||g.push(S)}}catch(t){b=!0,w=t}finally{try{!m&&z.return&&z.return()}finally{if(b)throw w}}return g}function circlesIntersect(t,e,r,i){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=t.dx(r),s=t.dy(r),a=t.dist(r);if(a>parseFloat(e)+parseFloat(i))return!1;if(a<parseFloat(i)-parseFloat(e))return!1;if(0===a&&e===i)return!1;var h=(Math.pow(e,2)-Math.pow(i,2)+Math.pow(a,2))/(2*a),p=Math.sqrt(Math.pow(e,2)-Math.pow(h,2)),u=t.x+h*o/a,f=t.y+h*s/a,c=new Point(u+p*s/a,f-p*o/a),l=new Point(u-p*s/a,f+p*o/a);return"x"===n&&c.x<=l.x||"y"===n&&c.y<=l.y?[c,l]:[l,c]}function beamIntersectsCircle(t,e,r,i){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=i.x-r.x,s=i.y-r.y,a=Math.pow(o,2)+Math.pow(s,2),h=2*(o*(r.x-t.x)+s*(r.y-t.y)),p=Math.pow(r.x-t.x,2)+Math.pow(r.y-t.y,2)-Math.pow(e,2),u=Math.pow(h,2)-4*a*p;if(a<=1e-7||u<0)return!1;if(0===u){var f=-1*h/(2*a);return[new Point(r.x+f*o,r.y+f*s)]}var c=(-1*h+Math.sqrt(u))/(2*a),l=new Point(r.x+c*o,r.y+c*s);c=(-1*h-Math.sqrt(u))/(2*a);var y=new Point(r.x+c*o,r.y+c*s);return"x"===n&&l.x<=y.x||"y"===n&&l.y<=y.y?[l,y]:[y,l]}function lineIntersectsCircle(t,e,r,i){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=beamIntersectsCircle(t,e,r,i,n);if(!1===o)return!1;if(1===o.length)return!!pointOnLine(r,i,o[0])&&o;var s=o[0],a=o[1];return!(!pointOnLine(r,i,s,5)&&!pointOnLine(r,i,a,5))&&(pointOnLine(r,i,s,5)&&pointOnLine(r,i,a,5)?"x"===n&&s.x<=a.x||"y"===n&&s.y<=a.y?[s,a]:[a,s]:pointOnLine(r,i,s,5)?[s]:pointOnLine(r,i,a,5)?[a]:void 0)}function curveEdge(t,e){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:500,i=1/0,n=1/0,o=void 0;"bottom"===e&&(n=-1/0),"right"===e&&(i=-1/0);for(var s=0;s<r;s++)o=t.get(s/r),("top"===e&&o.y<n||"bottom"===e&&o.y>n||"right"===e&&o.x>i||"left"===e&&o.x<i)&&(i=o.x,n=o.y);return new Point(i,n)}function stretchToScale(t){return 1/(1+parseFloat(t))}function round(t){return Math.round(100*t)/100}function sampleStyle(t,e){return"stroke: hsl("+330/e*(t-1)+", 100%, 35%);"}var utils$1=Object.freeze({capitalize:capitalize,macroName:macroName,beamsIntersect:beamsIntersect,linesIntersect:linesIntersect,pointOnBeam:pointOnBeam,pointOnLine:pointOnLine,pointOnCurve:pointOnCurve,beamIntersectsX:beamIntersectsX,beamIntersectsY:beamIntersectsY,units:units,lineIntersectsCurve:lineIntersectsCurve,curvesIntersect:curvesIntersect,circlesIntersect:circlesIntersect,beamIntersectsCircle:beamIntersectsCircle,lineIntersectsCircle:lineIntersectsCircle,curveEdge:curveEdge,stretchToScale:stretchToScale,round:round,sampleStyle:sampleStyle}),_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},_extends=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var i in r)Object.prototype.hasOwnProperty.call(r,i)&&(t[i]=r[i])}return t};function Path(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new Attributes,this.ops=[]}function pathOffset(t,e){var r=[],i=void 0,n=!1;for(var o in t.ops){var s=t.ops[o];if("line"===s.type){var a=offsetLine(i,s.to,e);a&&r.push(a)}else if("curve"===s.type){var h=void 0,p=void 0;h=i.sitsRoughlyOn(s.cp1)?(new Path).move(i).curve(s.cp1,s.cp2,s.to).shiftAlong(2):s.cp1,p=s.cp2.sitsRoughlyOn(s.to)?(new Path).move(s.to).curve(s.cp2,s.cp1,i).shiftAlong(2):s.cp2;var u=new bezierJs({x:i.x,y:i.y},{x:h.x,y:h.y},{x:p.x,y:p.y},{x:s.to.x,y:s.to.y}),f=!0,c=!1,l=void 0;try{for(var y,v=u.offset(e)[Symbol.iterator]();!(f=(y=v.next()).done);f=!0){var d=y.value;r.push(asPath(d))}}catch(t){c=!0,l=t}finally{try{!f&&v.return&&v.return()}finally{if(c)throw l}}}else"close"===s.type&&(n=!0);s.to&&(i=s.to)}return joinPaths(r,n)}function offsetLine(t,e,r){if(t.x===e.x&&t.y===e.y)return!1;var i=t.angle(e)-90;return(new Path).move(t.shift(i,r)).line(e.shift(i,r))}function asPath(t){return(new Path).move(new Point(t.points[0].x,t.points[0].y)).curve(new Point(t.points[1].x,t.points[1].y),new Point(t.points[2].x,t.points[2].y),new Point(t.points[3].x,t.points[3].y))}function joinPaths(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=(new Path).move(t[0].ops[0].to),i=void 0,n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=!0,f=!1,c=void 0;try{for(var l,y=p.ops[Symbol.iterator]();!(u=(l=y.next()).done);u=!0){var v=l.value;if("curve"===v.type)r.curve(v.cp1,v.cp2,v.to);else{if("close"===v.type)throw new Error("Cannot join a closed paths with another");i&&!v.to.sitsRoughlyOn(i)&&r.line(v.to)}v.to&&(i=v.to)}}catch(t){f=!0,c=t}finally{try{!u&&y.return&&y.return()}finally{if(f)throw c}}}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return e&&r.close(),r}function shiftAlongBezier(t,e){for(var r=void 0,i=void 0,n=void 0,o=void 0,s=0,a=0;a<=100;a++){if(n=a/100,i=new Point((i=e.get(n)).x,i.y),a>0){if(s+(o=i.dist(r))>t)return i;s+=o}r=i}}function lineBoundingBox(t){var e=t.from,r=t.to;return e.x===r.x?e.y<r.y?{topLeft:e,bottomRight:r}:{topLeft:r,bottomRight:e}:e.y===r.y?e.x<r.x?{topLeft:e,bottomRight:r}:{topLeft:r,bottomRight:e}:e.x<r.x?e.y<r.y?{topLeft:e,bottomRight:r}:{topLeft:new Point(e.x,r.y),bottomRight:new Point(r.x,e.y)}:e.x>r.x?e.y<r.y?{topLeft:new Point(r.x,e.y),bottomRight:new Point(e.x,r.y)}:{topLeft:new Point(r.x,r.y),bottomRight:new Point(e.x,e.y)}:void 0}function curveBoundingBox(t){var e=t.bbox();return{topLeft:new Point(e.x.min,e.y.min),bottomRight:new Point(e.x.max,e.y.max)}}function bbbbox(t){var e=1/0,r=-1/0,i=1/0,n=-1/0,o=!0,s=!1,a=void 0;try{for(var h,p=t[Symbol.iterator]();!(o=(h=p.next()).done);o=!0){var u=h.value;u.topLeft.x<e&&(e=u.topLeft.x),u.topLeft.y<i&&(i=u.topLeft.y),u.bottomRight.x>r&&(r=u.bottomRight.x),u.bottomRight.y>n&&(n=u.bottomRight.y)}}catch(t){s=!0,a=t}finally{try{!o&&p.return&&p.return()}finally{if(s)throw a}}return{topLeft:new Point(e,i),bottomRight:new Point(r,n)}}function edgeCurveAsBezier(t){return new bezierJs({x:t.from.x,y:t.from.y},{x:t.cp1.x,y:t.cp1.y},{x:t.cp2.x,y:t.cp2.y},{x:t.to.x,y:t.to.y})}function addIntersectionsToArray(t,e){if(t&&"object"===(void 0===t?"undefined":_typeof(t)))if("number"==typeof t.x)e.push(t);else{var r=!0,i=!1,n=void 0;try{for(var o,s=t[Symbol.iterator]();!(r=(o=s.next()).done);r=!0){var a=o.value;e.push(a)}}catch(t){i=!0,n=t}finally{try{!r&&s.return&&s.return()}finally{if(i)throw n}}}}function Snippet(t,e){return this.def=t,this.anchor=e,this.attributes=new Attributes,this}Path.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},Path.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},Path.prototype.curve=function(t,e,r){return this.ops.push({type:"curve",cp1:t,cp2:e,to:r}),this},Path.prototype._curve=function(t,e){var r=this.ops.slice(-1).pop().to;return this.ops.push({type:"curve",cp1:r,cp2:t,to:e}),this},Path.prototype.curve_=function(t,e){var r=e.copy();return this.ops.push({type:"curve",cp1:t,cp2:r,to:e}),this},Path.prototype.close=function(){return this.ops.push({type:"close"}),this},Path.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Path.prototype.asPathstring=function(){var t="",e=!0,r=!1,i=void 0;try{for(var n,o=this.ops[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;switch(s.type){case"move":t+="M "+s.to.x+","+s.to.y;break;case"line":t+=" L "+s.to.x+","+s.to.y;break;case"curve":t+=" C "+s.cp1.x+","+s.cp1.y+" "+s.cp2.x+","+s.cp2.y+" "+s.to.x+","+s.to.y;break;case"close":t+=" z"}}}catch(t){r=!0,i=t}finally{try{!e&&o.return&&o.return()}finally{if(r)throw i}}return t},Path.prototype.offset=function(t){return pathOffset(this,t)},Path.prototype.length=function(){var t=void 0,e=void 0,r=0;for(var i in this.ops){var n=this.ops[i];"move"===n.type?e=n.to:"line"===n.type?r+=t.dist(n.to):"curve"===n.type?r+=new bezierJs({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}).length():"close"===n.type&&(r+=t.dist(e)),n.to&&(t=n.to)}return round(r)},Path.prototype.start=function(){return this.ops[0].to},Path.prototype.end=function(){var t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},Path.prototype.boundary=function(){if(this.topLeft)return this;var t=void 0,e=new Point(1/0,1/0),r=new Point(-1/0,-1/0),i=[];for(var n in this.ops){var o=this.ops[n];if("move"===o.type||"line"===o.type)o.to.x<e.x&&(e.x=o.to.x,i.leftOp=n),o.to.y<e.y&&(e.y=o.to.y,i.topOp=n),o.to.x>r.x&&(r.x=o.to.x,i.rightOp=n),o.to.y>r.y&&(r.y=o.to.y,i.bottomOp=n);else if("curve"===o.type){var s=new bezierJs({x:t.x,y:t.y},{x:o.cp1.x,y:o.cp1.y},{x:o.cp2.x,y:o.cp2.y},{x:o.to.x,y:o.to.y}).bbox();s.x.min<e.x&&(e.x=s.x.min,i.leftOp=n),s.y.min<e.y&&(e.y=s.y.min,i.topOp=n),s.x.max>r.x&&(r.x=s.x.max,i.rightOp=n),s.y.max>r.y&&(r.y=s.y.max,i.bottomOp=n)}o.to&&(t=o.to)}this.topLeft=e,this.bottomRight=r;for(var a=["top","left","bottom","right"],h=0;h<a.length;h++){var p=a[h]+"Op";this[p]=this.ops[i[p]],this[p].from="move"===this[p].type?this[p].to:this.ops[i[p]-1].to}return this},Path.prototype.clone=function(){var t=new Path;for(var e in t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[],this.ops){var r=this.ops[e];t.ops[e]={type:r.type},"move"===r.type||"line"===r.type?t.ops[e].to=r.to.clone():"curve"===r.type&&(t.ops[e].to=r.to.clone(),t.ops[e].cp1=r.cp1.clone(),t.ops[e].cp2=r.cp2.clone())}return t},Path.prototype.join=function(t){return joinPaths([this,t],arguments.length>1&&void 0!==arguments[1]&&arguments[1])},Path.prototype.shiftAlong=function(t){var e=0,r=void 0;for(var i in this.ops){var n=this.ops[i];if("line"===n.type){var o=n.to.dist(r);if(e+o>t)return r.shiftTowards(n.to,t-e);e+=o}else if("curve"===n.type){var s=new bezierJs({x:r.x,y:r.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}),a=s.length();if(e+a>t)return shiftAlongBezier(t-e,s);e+=a}r=n.to}throw new Error("Ran out of path to shift along")},Path.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},Path.prototype.bbox=function(){var t=[],e=void 0;for(var r in this.ops){var i=this.ops[r];"line"===i.type?t.push(lineBoundingBox({from:e,to:i.to})):"curve"===i.type&&t.push(curveBoundingBox(new bezierJs({x:e.x,y:e.y},{x:i.cp1.x,y:i.cp1.y},{x:i.cp2.x,y:i.cp2.y},{x:i.to.x,y:i.to.y}))),i.to&&(e=i.to)}return bbbbox(t)},Path.prototype.reverse=function(){var t=[],e=void 0,r=!1;for(var i in this.ops){var n=this.ops[i];"line"===n.type?n.to.sitsOn(e)||t.push((new Path).move(n.to).line(e)):"curve"===n.type?t.push((new Path).move(n.to).curve(n.cp2,n.cp1,e)):"close"===n.type&&(r=!0),n.to&&(e=n.to)}var o=(new Path).move(e),s=!0,a=!1,h=void 0;try{for(var p,u=t.reverse()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;o.ops.push(f.ops[1])}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return r&&o.close(),o},Path.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new Point(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new Point(this.topLeft.x,this.bottomRight.y);var e=t+"Op";if("move"===this[e].type)return this[e].to;if("line"===this[e].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[e].type){return curveEdge(edgeCurveAsBezier(this[e]),t)}},Path.prototype.divide=function(){var t=[],e=void 0,r=void 0;for(var i in this.ops){var n=this.ops[i];"move"===n.type?r=n.to:"line"===n.type?n.to.sitsRoughlyOn(e)||t.push((new Path).move(e).line(n.to)):"curve"===n.type?t.push((new Path).move(e).curve(n.cp1,n.cp2,n.to)):"close"===n.type&&t.push((new Path).move(e).line(r)),n.to&&(e=n.to)}return t},Path.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},Path.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},Path.prototype.intersectsAxis=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0],e=arguments[1];if(!1===t)throw new Error("Path.intersects[X-Y] requires an value as parameter");var r=[],i="x"===e?new Point(t,-1e5):new Point(-1e4,t),n="x"===e?new Point(t,1e5):new Point(1e5,t),o=!0,s=!1,a=void 0;try{for(var h,p=this.divide()[Symbol.iterator]();!(o=(h=p.next()).done);o=!0){var u=h.value;"line"===u.ops[1].type?addIntersectionsToArray(linesIntersect(u.ops[0].to,u.ops[1].to,i,n),r):"curve"===u.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(i,n,u.ops[0].to,u.ops[1].cp1,u.ops[1].cp2,u.ops[1].to),r)}}catch(t){s=!0,a=t}finally{try{!o&&p.return&&p.return()}finally{if(s)throw a}}return r},Path.prototype.intersects=function(t){if(this===t)throw new Error("Calculating intersections between two identical paths is bad idea");var e=[],r=!0,i=!1,n=void 0;try{for(var o,s=this.divide()[Symbol.iterator]();!(r=(o=s.next()).done);r=!0){var a=o.value,h=!0,p=!1,u=void 0;try{for(var f,c=t.divide()[Symbol.iterator]();!(h=(f=c.next()).done);h=!0){var l=f.value;"line"===a.ops[1].type?"line"===l.ops[1].type?addIntersectionsToArray(linesIntersect(a.ops[0].to,a.ops[1].to,l.ops[0].to,l.ops[1].to),e):"curve"===l.ops[1].type&&addIntersectionsToArray(lineIntersectsCurve(a.ops[0].to,a.ops[1].to,l.ops[0].to,l.ops[1].cp1,l.ops[1].cp2,l.ops[1].to),e):"curve"===a.ops[1].type&&("line"===l.ops[1].type?addIntersectionsToArray(lineIntersectsCurve(l.ops[0].to,l.ops[1].to,a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to),e):"curve"===l.ops[1].type&&addIntersectionsToArray(curvesIntersect(a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to,l.ops[0].to,l.ops[1].cp1,l.ops[1].cp2,l.ops[1].to),e))}}catch(t){p=!0,u=t}finally{try{!h&&c.return&&c.return()}finally{if(p)throw u}}}}catch(t){i=!0,n=t}finally{try{!r&&s.return&&s.return()}finally{if(i)throw n}}return e},Path.prototype.split=function(t){var e=this.divide(),r=!1,i=!1;for(var n in e){var o=e[n];if("line"===o.ops[1].type)pointOnLine(o.ops[0].to,o.ops[1].to,t)&&((r=e.slice(0,n)).push((new Path).move(o.ops[0].to).line(t)),n++,(i=e.slice(n)).unshift((new Path).move(t).line(o.ops[1].to)));else if("curve"===o.ops[1].type){var s=pointOnCurve(o.ops[0].to,o.ops[1].cp1,o.ops[1].cp2,o.ops[1].to,t);if(!1!==s){var a=new bezierJs({x:o.ops[0].to.x,y:o.ops[0].to.y},{x:o.ops[1].cp1.x,y:o.ops[1].cp1.y},{x:o.ops[1].cp2.x,y:o.ops[1].cp2.y},{x:o.ops[1].to.x,y:o.ops[1].to.y}).split(s);(r=e.slice(0,n)).push((new Path).move(new Point(a.left.points[0].x,a.left.points[0].y)).curve(new Point(a.left.points[1].x,a.left.points[1].y),new Point(a.left.points[2].x,a.left.points[2].y),new Point(a.left.points[3].x,a.left.points[3].y))),n++,(i=e.slice(n)).unshift((new Path).move(new Point(a.right.points[0].x,a.right.points[0].y)).curve(new Point(a.right.points[1].x,a.right.points[1].y),new Point(a.right.points[2].x,a.right.points[2].y),new Point(a.right.points[3].x,a.right.points[3].y)))}}}return r&&(r=joinPaths(r)),i&&(i=joinPaths(i)),[r,i]},Path.prototype.trim=function(){var t=this.divide();for(var e in t)for(var r=parseInt(e)+2,i=parseInt(t.length)-1,n=r;n<i;n++){var o=t[e].intersects(t[n]);if(o.length>0){for(var s=o.pop(),a=t.slice(0,e),h=t.slice(parseInt(n)+1),p=new Path,u=!0,f=[e,n],c=0;c<f.length;c++){var l=t[f[c]].ops;if("line"===l[1].type)p.line(s);else if("curve"===l[1].type){var y=new bezierJs({x:l[0].to.x,y:l[0].to.y},{x:l[1].cp1.x,y:l[1].cp1.y},{x:l[1].cp2.x,y:l[1].cp2.y},{x:l[1].to.x,y:l[1].to.y}),v=pointOnCurve(l[0].to,l[1].cp1,l[1].cp2,l[1].to,s),d=y.split(v),x=void 0;x=u?d.left:d.right,p.curve(new Point(x.points[1].x,x.points[1].y),new Point(x.points[2].x,x.points[2].y),new Point(x.points[3].x,x.points[3].y))}u=!1}var g=void 0;return g=a.length>0?joinPaths(a).join(p):p,h.length>0&&(g=g.join(joinPaths(h))),g.trim()}}return this},Path.prototype.translate=function(t,e){var r=this.clone(),i=!0,n=!1,o=void 0;try{for(var s,a=r.ops[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;"close"!==h.type&&(h.to=h.to.translate(t,e)),"curve"===h.type&&(h.cp1=h.cp1.translate(t,e),h.cp2=h.cp2.translate(t,e))}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}return r},Snippet.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Snippet.prototype.clone=function(){var t=new Snippet(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t};var hooks={preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]};function Part(){return this.attributes=new Attributes,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=utils$1,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this.hooks=hooks,this}Part.prototype.macroClosure=function(t){var e=this;return function(t,r){var i=macroName(t);"function"==typeof e[i]?e[i](r):e.debug({type:"warning",label:"🚨 Macro not found",msg:"Macro "+t+" is not registered"})}},Part.prototype.debugClosure=function(){var t=this;return function(e){t.debug(e)}},Part.prototype.runHooks=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===e&&(e=this);var r=this.hooks[t];if(r.length>0){var i=!0,n=!1,o=void 0;try{for(var s,a=r[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;h.method(e,h.data)}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}}},Part.prototype.debug=function(t){this.runHooks("debug",t)},Part.prototype.getId=function(){return this.freeId+=1,""+this.freeId},Part.prototype.unitsClosure=function(t){var e=this;return function(t){return units(t,e.context.settings.units)}},Part.prototype.boundary=function(){if(this.topLeft)return this;var t=new Point(1/0,1/0),e=new Point(-1/0,-1/0);for(var r in this.paths){var i=this.paths[r].boundary();i.render&&(i.topLeft.x<t.x&&(t.x=i.topLeft.x),i.topLeft.y<t.y&&(t.y=i.topLeft.y),i.bottomRight.x>e.x&&(e.x=i.bottomRight.x),i.bottomRight.y>e.y&&(e.y=i.bottomRight.y))}for(var n in this.points){var o=this.points[n],s=o.attributes.get("data-circle");s&&(s=parseFloat(s),o.x-s<t.x&&(t.x=o.x-s),o.y-s<t.y&&(t.y=o.y-s),o.x+s>e.x&&(e.x=o.x+s),o.y+s>e.y&&(e.y=o.y+s))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),e.x===-1/0&&(e.x=0),e.y===-1/0&&(e.y=0);var a=this.context.settings.margin;return this.context.settings.paperless&&a<10&&(a=10),this.topLeft=new Point(t.x-a,t.y-a),this.bottomRight=new Point(e.x+a,e.y+a),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},Part.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform","translate("+-1*this.topLeft.x+", "+-1*this.topLeft.y+")"),this))},Part.prototype.attr=function(t,e){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,e):this.attributes.add(t,e),this},Part.prototype.inject=function(t){for(var e=["points","paths","snippets"],r=0;r<e.length;r++){var i=e[r];for(var n in t[i])void 0===this[i][n]&&(this[i][n]=t[i][n].clone())}return this},Part.prototype.units=function(t){return units(t,this.context.settings.units)},Part.prototype.shorthand=function(){var t=!!this.context.settings.complete,e=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:utils$1,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:e,debug:this.debugClosure()}};var version="0.28.1";function Svg(t){this.openGroups=[],this.layout={},this.freeId=0,this.body="",this.style="",this.script="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new Attributes,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",version)}Svg.prototype.runHooks=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===e&&(e=this);var r=this.hooks[t];if(r.length>0){var i=!0,n=!1,o=void 0;try{for(var s,a=r[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;h.method(e,h.data)}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}}},Svg.prototype.insertText=function(t){if(this.hooks.insertText.length>0){var e=!0,r=!1,i=void 0;try{for(var n,o=this.hooks.insertText[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;t=s.method(this.pattern.settings.locale,t,s.data)}}catch(t){r=!0,i=t}finally{try{!e&&o.return&&o.return()}finally{if(r)throw i}}}return t},Svg.prototype.debug=function(){},Svg.prototype.render=function(t){for(var e in this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox","0 0 "+t.width+" "+t.height),this.head=this.renderHead(),this.tail=this.renderTail(),this.svg="",this.layout={},t.parts){var r=t.parts[e];if(r.render&&t.needs(e)){var i=this.renderPart(r);this.layout[e]={svg:i,transform:r.attributes.getAsArray("transform")},this.svg+=this.openGroup(this.idPrefix+"part-"+e,r.attributes),this.svg+=i,this.svg+=this.closeGroup()}}return this.svg=this.prefix+this.renderSvgTag()+this.head+this.svg+this.tail,this.runHooks("postRender"),this.svg},Svg.prototype.renderHead=function(){var t=this.renderStyle();return t+=this.renderScript(),t+=this.renderDefs(),t+=this.openGroup(this.idPrefix+"container")},Svg.prototype.renderTail=function(){var t="";return t+=this.closeGroup(),t+=this.nl()+"</svg>"},Svg.prototype.renderSvgTag=function(){var t="<svg";return this.indent(),t+=this.nl()+this.attributes.render(),this.outdent(),t+=this.nl()+">"+this.nl()},Svg.prototype.renderStyle=function(){var t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},Svg.prototype.renderScript=function(){var t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},Svg.prototype.renderDefs=function(){var t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},Svg.prototype.renderPart=function(t){var e="";for(var r in t.paths){var i=t.paths[r];i.render&&(e+=this.renderPath(i))}for(var n in t.points)t.points[n].attributes.get("data-text")&&(e+=this.renderText(t.points[n])),t.points[n].attributes.get("data-circle")&&(e+=this.renderCircle(t.points[n]));for(var o in t.snippets){var s=t.snippets[o];e+=this.renderSnippet(s,t)}return e},Svg.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),this.nl()+"<path "+t.attributes.render()+" />"+this.renderPathText(t)},Svg.prototype.renderPathText=function(t){var e=t.attributes.get("data-text");if(!e)return"";this.text=this.insertText(e);var r=t.attributes.renderIfPrefixIs("data-text-"),i="",n=t.attributes.get("data-text-class");n&&n.indexOf("center")>-1?i=' startOffset="50%" ':n&&n.indexOf("right")>-1&&(i=' startOffset="100%" ');var o=this.nl()+"<text>";return this.indent(),o+='<textPath xlink:href="#'+t.attributes.get("id")+'" '+i+"><tspan "+r+">"+this.text+"</tspan></textPath>",this.outdent(),o+=this.nl()+"</text>"},Svg.prototype.renderText=function(t){var e=t.attributes.getAsArray("data-text");if(!1!==e){var r="",i=!0,n=!1,o=void 0;try{for(var s,a=e[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;this.text=this.insertText(h),r+=this.text+" "}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}this.text=this.insertText(r)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);var p=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");var u=this.nl()+"<text "+t.attributes.renderIfPrefixIs("data-text-")+">";if(this.indent(),-1!==this.text.indexOf("\n")){var f=this.text.split("\n");u+="<tspan>"+f.shift()+"</tspan>";var c=!0,l=!1,y=void 0;try{for(var v,d=f[Symbol.iterator]();!(c=(v=d.next()).done);c=!0){var x=v.value;u+='<tspan x="'+t.x+'" dy="'+p+'">'+x+"</tspan>"}}catch(t){l=!0,y=t}finally{try{!c&&d.return&&d.return()}finally{if(l)throw y}}}else u+="<tspan>"+this.text+"</tspan>";return this.outdent(),u+=this.nl()+"</text>"},Svg.prototype.renderCircle=function(t){return'<circle\n    cx="'+t.x+'"\n    cy="'+t.y+'"\n    r="'+t.attributes.get("data-circle")+'"\n    '+t.attributes.renderIfPrefixIs("data-circle-")+"\n  ></circle>"},Svg.prototype.renderSnippet=function(t,e){var r=t.anchor.x,i=t.anchor.y,n=t.attributes.get("data-scale");n&&(t.attributes.add("transform","translate("+r+", "+i+")"),t.attributes.add("transform","scale("+n+")"),t.attributes.add("transform","translate("+-1*r+", "+-1*i+")"));var o=t.attributes.get("data-rotate");o&&t.attributes.add("transform","rotate("+o+", "+r+", "+i+")");var s=this.nl();return s+='<use x="'+r+'" y="'+i+'" ',s+='xlink:href="#'+t.def+'" '+t.attributes.render()+">",s+="</use>"},Svg.prototype.openGroup=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=this.nl()+this.nl();return r+="\x3c!-- Start of group #"+t+" --\x3e",r+=this.nl(),r+='<g id="'+t+'"',e&&(r+=" "+e.render()),r+=">",this.indent(),this.openGroups.push(t),r},Svg.prototype.closeGroup=function(){return this.outdent(),this.nl()+"</g>"+this.nl()+"\x3c!-- end of group #"+this.openGroups.pop()+" --\x3e"},Svg.prototype.nl=function(){return"\n"+this.tab()},Svg.prototype.tab=function(){for(var t="",e=0;e<this.tabs;e++)t+="  ";return t},Svg.prototype.indent=function(){this.tabs+=1},Svg.prototype.outdent=function(){this.tabs-=1},Svg.prototype.getId=function(){return this.freeId+=1,""+this.freeId};var GrowingPacker=function(){};GrowingPacker.prototype={fit:function(t){var e,r,i,n,o=t.length,s=o>0?t[0].width:0,a=o>0?t[0].height:0;for(this.root={x:0,y:0,width:s,height:a},e=0;e<o;e++)i=t[e],(r=this.findNode(this.root,i.width,i.height))?(n=this.splitNode(r,i.width,i.height),i.x=n.x,i.y=n.y):(n=this.growNode(i.width,i.height),i.x=n.x,i.y=n.y)},findNode:function(t,e,r){return t.used?this.findNode(t.right,e,r)||this.findNode(t.down,e,r):e<=t.width&&r<=t.height?t:null},splitNode:function(t,e,r){return t.used=!0,t.down={x:t.x,y:t.y+r,width:t.width,height:t.height-r},t.right={x:t.x+e,y:t.y,width:t.width-e,height:r},t},growNode:function(t,e){var r=t<=this.root.width,i=e<=this.root.height,n=i&&this.root.height>=this.root.width+t,o=r&&this.root.width>=this.root.height+e;return n?this.growRight(t,e):o?this.growDown(t,e):i?this.growRight(t,e):r?this.growDown(t,e):null},growRight:function(t,e){var r;return this.root={used:!0,x:0,y:0,width:this.root.width+t,height:this.root.height,down:this.root,right:{x:this.root.width,y:0,width:t,height:this.root.height}},(r=this.findNode(this.root,t,e))?this.splitNode(r,t,e):null},growDown:function(t,e){var r;return this.root={used:!0,x:0,y:0,width:this.root.width,height:this.root.height+e,down:{x:0,y:this.root.height,width:this.root.width,height:e},right:this.root},(r=this.findNode(this.root,t,e))?this.splitNode(r,t,e):null}};var packer_growing=GrowingPacker,binPack=function(t,e){e=e||{};var r=new packer_growing,i=e.inPlace||!1,n=t.map(function(t){return i?t:{width:t.width,height:t.height,item:t}});n=n.sort(function(t,e){return e.width*e.height-t.width*t.height}),r.fit(n);var o={width:n.reduce(function(t,e){return Math.max(t,e.x+e.width)},0),height:n.reduce(function(t,e){return Math.max(t,e.y+e.height)},0)};return i||(o.items=n),o};function Store(){this.data=new Map}function Pattern(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{options:{}};for(var e in this.config=t,this.width=0,this.height=0,this.is="",this.store=new Store,this.parts={},this.hooks=hooks,this.Point=Point,this.Path=Path,this.Snippet=Snippet,this.Attributes=Attributes,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,layout:!0,options:{}},void 0===this.config.inject&&(this.config.inject=[]),void 0===this.config.dependencies&&(this.config.dependencies={}),void 0===this.config.hide&&(this.config.hide=[]),this.config.resolvedDependencies=this.resolveDependencies(this.config.dependencies),this.config.draftOrder=this.draftOrder(this.config.resolvedDependencies),t.options){var r=t.options[e];if("object"===(void 0===r?"undefined":_typeof(r)))if(void 0!==r.pct)this.settings.options[e]=r.pct/100;else if(void 0!==r.mm)this.settings.options[e]=r.mm;else if(void 0!==r.deg)this.settings.options[e]=r.deg;else if(void 0!==r.count)this.settings.options[e]=r.count;else if(void 0!==r.bool)this.settings.options[e]=r.bool;else{if(void 0===r.dflt)throw new Error("Unknown option type: "+JSON.stringify(r));this.settings.options[e]=r.dflt}else this.settings.options[e]=r}this.macros={};var i={parts:this.parts,config:this.config,settings:this.settings,store:this.store,macros:this.macros};this.Part=function(){var t=new Part;for(var e in t.context=i,i.macros)t[macroName(e)]=i.macros[e];return t}}Store.prototype.set=function(t,e){this.data.set(t,e)},Store.prototype.setIfUnset=function(t,e){this.data.has(t)||this.data.set(t,e)},Store.prototype.get=function(t){return this.data.get(t)},Pattern.prototype.apply=function(t){if("object"!==(void 0===t?"undefined":_typeof(t)))return this;var e=!0,r=!1,i=void 0;try{for(var n,o=Object.keys(t)[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;if(Array.isArray(t[s]))if(Array.isArray(this.settings[s])){var a=!0,h=!1,p=void 0;try{for(var u,f=t[s][Symbol.iterator]();!(a=(u=f.next()).done);a=!0){var c=u.value;this.settings[s].push(c)}}catch(t){h=!0,p=t}finally{try{!a&&f.return&&f.return()}finally{if(h)throw p}}}else this.settings[s]=t[s];else"object"===_typeof(t[s])?this.settings[s]=_extends({},this.settings[s],t[s]):this.settings[s]=t[s]}}catch(t){r=!0,i=t}finally{try{!e&&o.return&&o.return()}finally{if(r)throw i}}return this},Pattern.prototype.runHooks=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===e&&(e=this);var r=this.hooks[t];if(r.length>0){var i=!0,n=!1,o=void 0;try{for(var s,a=r[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;h.method(e,h.data)}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}}},Pattern.prototype.draft=function(){"sample"!==this.is&&(this.is="draft"),this.runHooks("preDraft");var t=!0,e=!1,r=void 0;try{for(var i,n=this.config.draftOrder[Symbol.iterator]();!(t=(i=n.next()).done);t=!0){var o=i.value;if(this.parts[o]=new this.Part,"string"==typeof this.config.inject[o]&&this.parts[o].inject(this.parts[this.config.inject[o]]),this.needs(o)){var s="draft"+capitalize(o);if("function"!=typeof this[s])throw new Error('Method "'+s+'" on pattern object is not callable');this.parts[o]=this[s](this.parts[o]),this.parts[o].render=this.wants(o)}}}catch(t){e=!0,r=t}finally{try{!t&&n.return&&n.return()}finally{if(e)throw r}}return this.runHooks("postDraft"),this},Pattern.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},Pattern.prototype.sampleParts=function(){var t={};for(var e in this.settings.complete=!1,this.settings.paperless=!1,this.draft(),this.parts)t[e]=new this.Part,t[e].render=this.parts[e].render;return t},Pattern.prototype.sampleRun=function(t,e,r,i){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4];for(var o in this.draft(),this.parts){var s=0,a=0;for(var h in this.parts[o].points.anchor&&(void 0===e[o]?e[o]=this.parts[o].points.anchor:e[o].sitsOn(this.parts[o].points.anchor)||(s=this.parts[o].points.anchor.dx(e[o]),a=this.parts[o].points.anchor.dy(e[o]))),this.parts[o].paths)t[o].paths[h+"_"+r]=this.parts[o].paths[h].clone().attr("style",sampleStyle(r,i)),this.parts[o].points.anchor&&(t[o].paths[h+"_"+r]=t[o].paths[h+"_"+r].translate(s,a)),!1!==n&&t[o].paths[h+"_"+r].attributes.add("class",n)}},Pattern.prototype.sampleOption=function(t){this.is="sample",this.runHooks("preSample");var e,r=void 0,i=1,n={},o=this.sampleParts(),s=this.config.options[t];if("object"===_typeof(s.list))return this.sampleListOption(t);void 0!==s.min&&void 0!==s.max||(s={min:.9*s,max:1.1*s});void 0!==s.pct&&(i=100),r=s.min/i,e=(s.max/i-r)/9;for(var a=1;a<11;a++)this.settings.options[t]=r,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:"Sampling option "+t+" with value "+round(r)}),this.sampleRun(o,n,a,10),r+=e;return this.parts=o,this.runHooks("postSample"),this},Pattern.prototype.sampleListOption=function(t){var e=this.sampleParts(),r=this.config.options[t],i={},n=1,o=r.list.length,s=!0,a=!1,h=void 0;try{for(var p,u=r.list[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;this.settings.options[t]=f,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:"Sampling option "+t+" with value "+round(f)}),this.sampleRun(e,i,n,o),n++}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return this.parts=e,this},Pattern.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");var e={},r=this.sampleParts(),i=this.settings.measurements[t];if(void 0===i)throw new Error("Cannot sample a measurement that is undefined: "+t);var n=i/50;i*=.9;for(var o=1;o<11;o++)this.settings.measurements[t]=i,this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:"Sampling option "+t+" with value "+round(i)}),this.sampleRun(r,e,o,10),i+=n;return this.parts=r,this.runHooks("postSample"),this},Pattern.prototype.sampleModels=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this.is="sample",this.runHooks("preSample");var r={},i=this.sampleParts(),n=0,o=Object.keys(t).length;for(var s in t){n++,this.settings.measurements=t[s],this.debug({type:"info",label:"🏃🏿‍♀️ Sample run",msg:"Sampling model "+s});var a=s===e?"sample-focus":"";this.sampleRun(i,r,n,o,a)}return this.parts=i,this.runHooks("postSample"),this},Pattern.prototype.debug=function(t){this.runHooks("debug",t)},Pattern.prototype.render=function(){return this.svg=new Svg(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},Pattern.prototype.on=function(t,e,r){this.hooks[t].push({method:e,data:r})},Pattern.prototype.use=function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this.debug({type:"success",label:"🔌 Plugin loaded",msg:t.name+" v"+t.version}),t.hooks&&this.loadPluginHooks(t,e),t.macros&&this.loadPluginMacros(t),this},Pattern.prototype.loadPluginHooks=function(t,e){var r=!0,i=!1,n=void 0;try{for(var o,s=Object.keys(this.hooks)[Symbol.iterator]();!(r=(o=s.next()).done);r=!0){var a=o.value;if("function"==typeof t.hooks[a])this.on(a,t.hooks[a],e);else if(Array.isArray(t.hooks[a])){var h=!0,p=!1,u=void 0;try{for(var f,c=t.hooks[a][Symbol.iterator]();!(h=(f=c.next()).done);h=!0){var l=f.value;this.on(a,l,e)}}catch(t){p=!0,u=t}finally{try{!h&&c.return&&c.return()}finally{if(p)throw u}}}}}catch(t){i=!0,n=t}finally{try{!r&&s.return&&s.return()}finally{if(i)throw n}}},Pattern.prototype.loadPluginMacros=function(t){for(var e in t.macros)"function"==typeof t.macros[e]&&this.macro(e,t.macros[e])},Pattern.prototype.macro=function(t,e){this.macros[t]=e},Pattern.prototype.pack=function(){var t=[];for(var e in this.parts){var r=this.parts[e];if(r.attributes.remove("transform"),r.render&&this.needs(e)){r.stack();var i=r.bottomRight.x-r.topLeft.x,n=r.bottomRight.y-r.topLeft.y;!0===this.settings.layout?t.push({id:e,width:i,height:n}):(this.width<i&&(this.width=i),this.height<n&&(this.height=n))}}if(!0===this.settings.layout){var o=binPack(t,{inPlace:!0}),s=!0,a=!1,h=void 0;try{for(var p,u=t[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value,c=this.parts[f.id];0===f.x&&0===f.y||c.attr("transform","translate ("+f.x+", "+f.y+")")}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}this.width=o.width,this.height=o.height}else if("object"===_typeof(this.settings.layout)){this.width=this.settings.layout.width,this.height=this.settings.layout.height;var l=!0,y=!1,v=void 0;try{for(var d,x=Object.keys(this.settings.layout.parts)[Symbol.iterator]();!(l=(d=x.next()).done);l=!0){var g=d.value,m=this.settings.layout.parts[g];"object"===_typeof(m.translate)&&this.parts[g].attributes.set("transform","translate("+m.translate.x+", "+m.translate.y+")")}}catch(t){y=!0,v=t}finally{try{!l&&x.return&&x.return()}finally{if(y)throw v}}}return this},Pattern.prototype.draftOrder=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.resolveDependencies(),e=[],r={};return Object.keys(t).forEach(function i(n,o){Array.isArray(o)||(o=[]),o.push(n),r[n]=!0,void 0!==t[n]&&t[n].forEach(function(t){r[t]||i(t,o.slice(0))}),e.indexOf(n)<0&&e.push(n)}),e},Pattern.prototype.resolveDependency=function(t,e){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.config.dependencies,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];if(void 0===t[e]&&(t[e]=!0),"string"==typeof r[e])return i.push(r[e]),this.resolveDependency(t,r[e],r,i);if(Array.isArray(r[e])){if(0===r[e].length)return[];0===i.length&&(i=r[e]);var n=!0,o=!1,s=void 0;try{for(var a,h=r[e][Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value;i.concat(this.resolveDependency(t,p,r,i))}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}}return i},Pattern.prototype.resolveDependencies=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.config.dependencies;if(Array.isArray(this.config.parts)){var e=!0,r=!1,i=void 0;try{for(var n,o=this.config.parts[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){var s=n.value;void 0===this.config.dependencies[s]&&(this.config.dependencies[s]=[])}}catch(t){r=!0,i=t}finally{try{!e&&o.return&&o.return()}finally{if(r)throw i}}}var a={},h={},p=!0,u=!1,f=void 0;try{for(var c,l=Object.keys(t)[Symbol.iterator]();!(p=(c=l.next()).done);p=!0){var y=c.value;a[y]=this.resolveDependency(h,y,t)}}catch(t){u=!0,f=t}finally{try{!p&&l.return&&l.return()}finally{if(u)throw f}}var v=!0,d=!1,x=void 0;try{for(var g,m=Object.keys(h)[Symbol.iterator]();!(v=(g=m.next()).done);v=!0){var b=g.value;void 0===a[b]&&(a[b]=[])}}catch(t){d=!0,x=t}finally{try{!v&&m.return&&m.return()}finally{if(d)throw x}}return a},Pattern.prototype.needs=function(t){if(void 0===this.settings.only||!1===this.settings.only)return!0;if("string"==typeof this.settings.only){if(this.settings.only===t)return!0;if(Array.isArray(this.config.resolvedDependencies[this.settings.only])){var e=!0,r=!1,i=void 0;try{for(var n,o=this.config.resolvedDependencies[this.settings.only][Symbol.iterator]();!(e=(n=o.next()).done);e=!0){if(n.value===t)return!0}}catch(t){r=!0,i=t}finally{try{!e&&o.return&&o.return()}finally{if(r)throw i}}}}else if(Array.isArray(this.settings.only)){var s=!0,a=!1,h=void 0;try{for(var p,u=this.settings.only[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;if(f===t)return!0;var c=!0,l=!1,y=void 0;try{for(var v,d=this.config.resolvedDependencies[f][Symbol.iterator]();!(c=(v=d.next()).done);c=!0){if(v.value===t)return!0}}catch(t){l=!0,y=t}finally{try{!c&&d.return&&d.return()}finally{if(l)throw y}}}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}}return!1},Pattern.prototype.isHidden=function(t){return!(!Array.isArray(this.config.hide)||-1===this.config.hide.indexOf(t))},Pattern.prototype.wants=function(t){if(void 0===this.settings.only||!1===this.settings.only){if(this.isHidden(t))return!1}else{if("string"==typeof this.settings.only)return this.settings.only===t;if(Array.isArray(this.settings.only)){var e=!0,r=!1,i=void 0;try{for(var n,o=this.settings.only[Symbol.iterator]();!(e=(n=o.next()).done);e=!0){if(n.value===t)return!0}}catch(t){r=!0,i=t}finally{try{!e&&o.return&&o.return()}finally{if(r)throw i}}return!1}}return!0};var index={version:version,Pattern:Pattern,Point:Point,Path:Path,Snippet:Snippet,utils:utils$1,patterns:{},plugins:{}};export default index;
//# sourceMappingURL=index.mjs.map
